Attribute VB_Name = "MAINAPP"
Option Explicit

Const wx = 256
Const wy = wx
Const hscale = (wx + wy) * 2.47
Const Divisions = 64
Const xScalar = 64
Const yScalar = 63
Const FullRange = ((xScalar / Divisions) + (yScalar / Divisions)) * 250000
Const xScale = wx * xScalar
Const yScale = wy * yScalar
Const xShift = (wx / 2) * xScale
Const yShift = (wy / 2) * yScale
Public DX As New DXCLASS

Public Sub Main()
    On Error GoTo errs
    With DX
        If Not .Initialize(, , , , , , 800) Then GoTo errs
        .OGRECamera.Create xScale, hscale * 200, 0, xScale + 250, hscale * 200, 0, , FullRange
        GenerateTerrain
        '.OGRE3DS.Load "ship3", "alex", xScale
        '.OGRELight.CreatePoint "Light1", 1, 1, 0, xScale, hscale * 120, 0, hscale * 230
        .OGRESurface.CreateTexture "alexc.bmp", "alex2", , , , True
        Dim PitchScale As Single
        Do
            .BeginScene
            .OGREMesh.DrawAll
            .EndScene 1
            .AppComplete = .KeyState(27)
            PitchScale = 0.1 * .TimeElapsed
            With .OGRECamera
                If DX.KeyState(Asc("A")) Then .MoveAtHRelative PitchScale, 50, 50
                If DX.KeyState(Asc("D")) Then .MoveAtHRelative -PitchScale, 50, 50
                If DX.KeyState(Asc("Q")) Then .MoveAtVRelative -PitchScale
                If DX.KeyState(Asc("E")) Then .MoveAtVRelative PitchScale
                    
                If .CameraFrom.x < -xShift + xScale Then .CameraFrom.x = -xShift + 2 * xScale
                If .CameraFrom.z > yShift - yScale Then .CameraFrom.z = yShift - 2 * yScale
                If .CameraFrom.x > xShift - xScale Then .CameraFrom.x = xShift - 2 * xScale
                If .CameraFrom.z < -yShift + yScale Then .CameraFrom.z = -yShift + 2 * yScale
            
                If DX.KeyState(Asc("S")) And (.CameraFrom.x > -xShift + xScale) And (.CameraFrom.z < yShift - yScale) _
                    And (.CameraFrom.x < xShift - xScale) And (.CameraFrom.z > -yShift + yScale) Then .MoveCameraRelative -Cos(DX.Rads(.LookHorz)) * xScale, , -Sin(DX.Rads(.LookHorz)) * yScale, -Cos(DX.Rads(.LookHorz)) * xScale, , -Sin(DX.Rads(.LookHorz)) * yScale
            
                If DX.KeyState(Asc("W")) And (.CameraFrom.x > -xShift + xScale) And (.CameraFrom.z < yShift - yScale) _
                    And (.CameraFrom.x < xShift - xScale) And (.CameraFrom.z > -yShift + yScale) Then .MoveCameraRelative Cos(DX.Rads(.LookHorz)) * xScale, , Sin(DX.Rads(.LookHorz)) * yScale, Cos(DX.Rads(.LookHorz)) * xScale, , Sin(DX.Rads(.LookHorz)) * yScale
                    
            End With
        Loop Until .AppComplete
    End With
errs:
    Set DX = Nothing
    End
End Sub

Public Function MakeVector(x, y, z) As D3DVECTOR
    MakeVector.x = x
    MakeVector.y = y
    MakeVector.z = z
End Function

Public Sub GenerateTerrain()
    Dim land() As Single
    ReDim land(wx, wy)
    Dim x As Long, y As Long, I As Long
    Dim EmptyRect As RECT
    
    With DX
        .OGRESurface.CreateSurface "alex.bmp", "alex"
        Dim ddsd As DDSURFACEDESC2
        With .OGRESurface.Info("alex")
            .Lock EmptyRect, ddsd, DDLOCK_WAIT, 0
            For x = 1 To wx
                For y = 1 To wy
                    land(x, y) = (.GetLockedPixel(x, y)) / 256
                Next y
            Next x
            .Unlock EmptyRect
        End With
        .OGRESurface.Remove "alex"
        
        Dim Index As Long, Index2 As Long, Index3 As Long
        Dim y1 As Single, x1 As Single, xp1 As Single, iPos As Single, iPos2 As Single
        Dim Xv As Single, Yv As Single, pX1 As Single, pX2 As Single, pZ1 As Single, pZ2 As Single, ty As Single
        Dim BS As Single
        
        With .OGREMesh
            iPos = wx / Divisions
            iPos2 = wy / Divisions
            BS = Sqr(Divisions) / 1000
            For Index = 1 To Divisions
                ' For quicker calculations on the vertices and the Center-X vector
                pX1 = (Index - 1) * iPos
                pX2 = Index * iPos
                ' for the Center-X vector
                Xv = (pX1 + pX2) * 0.5 * xScale - xShift
                For Index2 = 1 To Divisions
                    ' for quicker calculations on the vertices and the Center-Z vector
                    pZ1 = (Index2 - 1) * iPos2
                    pZ2 = Index2 * iPos2
                    Index3 = .Create("alex2")
                    For x = pX1 To pX2 - 1
                        ' For the X texture coordinates
                        x1 = x * BS
                        xp1 = (x + 1) * BS
                        For y = pZ1 To pZ2
                            ' for the Y texture corrdinates
                            y1 = y * BS
                            ' for the Center-Y vector
                            Yv = IIf(land(x, y) > land(x + 1, y), land(x, y), land(x + 1, y))
                            If y + 1 <= wy Then
                                Yv = IIf(land(x, y + 1) > Yv, land(x, y + 1), Yv)
                                Yv = IIf(land(x + 1, y + 1) > Yv, land(x + 1, y + 1), Yv)
                            End If
                            ty = y * yScale - yShift
                            ' the actual vertex creation
                            .CreateVertex Index3, (x + 1) * xScale - xShift, land(x + 1, y) * hscale, ty, xp1, y1
                            .CreateVertex Index3, x * xScale - xShift, land(x, y) * hscale, ty, x1, y1
                        Next y
                    Next x
                    ' Scale the Center-Y point
                    Yv = Yv * hscale * 0.5
                    .SetSphere Index3, MakeVector(Xv, Yv, (pZ1 + pZ2) * 0.5 * yScale - yShift), hscale * 62.5
                Next Index2
            Next Index
        End With
    End With
End Sub
