VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "CConsole"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Option Explicit
Option Base 0

Implements OGREGUIBase

Const FONT_Y_SIZE = 12       ' Height

Private m_Active  As Boolean              ' Is the console active?
Private m_prompt  As String
Private LineIndex   As Integer
Public m_line      As CLine                ' The current line
Public m_buffer    As CBuffer              ' The whole console buffer
Public m_textColor As Long

Const MaxArgs = 8

Public Sub OGREGUIBase_ProcessKeyInput(KeyCode As Long)
    Select Case KeyCode
        Case vbKeyUp:
            If LineIndex - 1 >= -1 Then
                m_line.SetData m_buffer.GetData(LineIndex)
                LineIndex = LineIndex - 1
            End If
        Case vbKeyDown:
            With m_buffer
                If LineIndex + 1 <= .m_curLines Then
                    LineIndex = LineIndex + 1
                    m_line.SetData .GetData(LineIndex)
                ElseIf LineIndex + 1 > .m_curLines Then
                    m_line.Clear
                    m_line.SetData m_prompt
                End If
            End With
        
        Case vbKeySpace, 44 To 57, 63 To 90, 97 To 122: m_line.Append Chr(KeyCode)
        Case vbKeyBack: If Len(m_prompt) < m_line.m_curSize Then m_line.Pop 1
        Case vbKeyReturn:
            m_buffer.Append m_line.m_data
            Parse Right(m_line.m_data, Len(m_line.m_data) - Len(m_prompt))
            m_line.Clear
            m_line.SetData m_prompt
            LineIndex = m_buffer.m_curLines
    End Select
End Sub

Private Sub Parse(ByVal m_cmdStr As String)
    Dim I As Long
    Dim J As Long
    Dim C As String
    Dim tmp As String
    Dim m_cmd(MaxArgs) As String
    Dim ErrString As String
    J = 0
    
    For I = 1 To Len(m_cmdStr)
        C = UCase(Mid(m_cmdStr, I, 1))
        If C = " " Or C = vbTab Or C = "," Then
            If tmp = "ON" Then tmp = "1"
            If tmp = "OFF" Then tmp = "0"
            m_cmd(J) = tmp
            tmp = ""
            J = J + 1
            If J > MaxArgs Then
                PrintData "Too Many Arguments"
                m_cmd(0) = "/H"
                m_cmd(1) = ""
                GoTo TooMany
            End If
        Else
            tmp = tmp & C
        End If
    Next
    m_cmd(J) = tmp

TooMany:
    On Error GoTo errs
    Select Case m_cmd(0)
        Case "TIME":
            PrintData Now()
        Case "FAR":
            ErrString = "FAR Number"
            Camera.Range , CSng(m_cmd(1))
        Case "NEAR":
            ErrString = "NEAR Number"
            Camera.Range CSng(m_cmd(1))
        Case "ROLL":
            ErrString = "ROLL Number"
            Camera.Range , , , CSng(m_cmd(1))
        Case "FOV":
            ErrString = "FOV Number"
            Camera.Range , , CSng(m_cmd(1))
        Case "CAM":
            ErrString = "Cam [Sub Command] (Arguments)"
            Select Case m_cmd(1)
                Case "M":
                    ErrString = "Cam M X Y Z"
                    Camera.Move CSng(m_cmd(2)), CSng(m_cmd(3)), CSng(m_cmd(4))
                Case "L":
                    ErrString = "Cam L X Y Z"
                    Camera.Look CSng(m_cmd(2)), CSng(m_cmd(3)), CSng(m_cmd(4))
                Case "R":
                    ErrString = "Cam R Near Far FOV Roll"
                    Camera.Range CSng(m_cmd(2)), CSng(m_cmd(3)), CSng(m_cmd(4)), CSng(m_cmd(5))
                Case Else:
                    PrintData "Sub Command Error"
                    EnterCommand "/H CAM"
            End Select
        Case "LT":
            ErrString = "Lt [Sub Command] LightName (Arguments)"
            Select Case m_cmd(1)
                Case "M":
                    ErrString = "Lt M Light,X,Y,Z"
                    Lights.Move m_cmd(2), CSng(m_cmd(3)), CSng(m_cmd(4)), CSng(m_cmd(5))
                Case "R":
                    ErrString = "Lt R Light,Range"
                    Lights.Range m_cmd(2), CSng(m_cmd(3))
                Case "X":
                    ErrString = "Lt X Light"
                    Lights.Delete m_cmd(2)
                Case "A":
                    ErrString = "Lt A Light,Red,Green,Blue"
                    Lights.Ambient m_cmd(2), CSng(m_cmd(3)), CSng(m_cmd(4)), CSng(m_cmd(5))
                Case "S":
                    ErrString = "Lt S Light,Red,Green,Blue"
                    Lights.Specular m_cmd(2), CSng(m_cmd(3)), CSng(m_cmd(4)), CSng(m_cmd(5))
                Case "D":
                    ErrString = "Lt D Light,Red,Green,Blue"
                    Lights.Diffuse m_cmd(2), CSng(m_cmd(3)), CSng(m_cmd(4)), CSng(m_cmd(5))
                Case Else:
                    PrintData "Sub Command Error"
                    EnterCommand "/H LT"
            End Select
        Case "SNAP":
            ErrString = "Snap (Filename)"
            If Camera.CaptureWindow(m_cmd(1)) Then PrintData "Screen captured. Saved as " & m_cmd(1) & ".bmp"
        Case "SHOWFPS":
            ErrString = "ShowFPS (True | False)"
            FPSON = CBool(m_cmd(1))
        Case "/H":
            Select Case m_cmd(1)
                Case "TIME":
                    PrintData "Current time and date"
                Case "FAR":
                    PrintData "Change current camera FAR plane"
                Case "NEAR":
                    ErrString = "Change current camera NEAR plane"
                Case "ROLL":
                    ErrString = "Change current camera ROLL angle"
                Case "FOV":
                    ErrString = "Change current camera FOV angle"
                Case "CAM":
                    PrintData "Change look at point (L)"
                    PrintData "Move the camera      (M)"
                    PrintData "Change Camera Ranges (R)"
                Case "SNAP":
                    PrintData "Takes a screen shot (BMP format)"
                Case "SHOWFPS":
                    PrintData "Turns the FPS display (ON/OFF)"
                Case "LT":
                    PrintData "Change Light Ambiance    (A)"
                    PrintData "Change Light Diffusion   (D)"
                    PrintData "Move the Light           (M)"
                    PrintData "New Range for Light      (R)"
                    PrintData "Change Light Specularity (S)"
                    PrintData "Delete a Light           (X)"
                Case Else
                    PrintData "Welcome to the OGRE console"
                    PrintData "  Updated October 28 1999"
                    PrintData ""
                    PrintData "Help is for the following topics:"
                    PrintData ""
                    PrintData "  CAM   SHOWFPS   LT"
                    PrintData "  FOV    SNAP   NEAR"
                    PrintData "  FAR    ROLL   TIME"
                    PrintData ""
                    PrintData "   Note that all boolean operations"
                    PrintData "ON/OFF,TRUE/FALSE, or 1/0 can be used"
                    PrintData ""
                    PrintData "Type /H [Topic] for more information"
            End Select
            PrintData ""
        Case vbKeySpace, "":
        Case Else:
            PrintData "Unknown Command"
            EnterCommand "/H"
    End Select
    Exit Sub
errs:
    PrintData "Command Syntax Invalid - " & ErrString
End Sub

Private Sub EnterCommand(ByVal cmd As String)
    ' Enters a command as if the user entered it by him/her-self
    m_line.Clear
    m_line.SetData m_prompt
    m_line.Append cmd
    m_buffer.Append m_line.m_data
    Parse Right(m_line.m_data, Len(m_line.m_data) - Len(m_prompt))
    m_line.Clear
    m_line.SetData m_prompt
End Sub

Private Function PrintData(ByVal fmt As String)
    m_line.Clear
    m_line.SetData m_prompt & fmt
    m_buffer.Append m_line.m_data
    m_line.Clear
    m_line.SetData m_prompt
End Function

Public Sub OGREGUIBase_Render()
    Dim I As Long, y As Long
    Dim tmp As String
            
    For I = 0 To m_buffer.m_curLines + 1
        If m_buffer.m_curLines + 1 = I Then
            tmp = m_line.m_data
        Else
            tmp = m_buffer.GetData(I)
        End If
                        
        sBackBuffer.SetForeColor m_textColor
        sBackBuffer.DrawText 5, y + 65, tmp, False
        y = y + FONT_Y_SIZE
    Next
End Sub

Private Sub OGREguibase_Clear()
    m_buffer.Pop m_buffer.m_curLines
    m_buffer.m_curLines = -1
    m_line.Clear
    m_line.SetData m_prompt
End Sub

Private Sub Class_Initialize()
    Set m_buffer = New CBuffer
    Set m_line = New CLine
    OGREGUIBase_ToggleActive
    m_line.Resize
    m_prompt = "% "
    m_line.SetData OGREGUIBase_Prompt
    LineIndex = -1
End Sub

Private Sub Class_Terminate()
    Set m_buffer = Nothing
    Set m_line = Nothing
End Sub

Private Property Get OGREGUIBase_Active() As Boolean
    OGREGUIBase_Active = m_Active
End Property

Private Sub OGREGUIBase_Resize()

End Sub

Private Property Let OGREGUIBase_TextColor(ByVal RHS As Long)
    m_textColor = RHS
End Property

Private Property Get OGREGUIBase_TextColor() As Long
    OGREGUIBase_TextColor = m_textColor
End Property

Private Sub OGREGUIBase_ToggleActive()
    m_Active = Not m_Active
End Sub

Private Property Let OGREGUIBase_Prompt(ByVal RHS As String)
    m_prompt = RHS
End Property

Private Property Get OGREGUIBase_Prompt() As String
    OGREGUIBase_Prompt = m_prompt
End Property

Private Sub OGREGUIBase_Click()
End Sub

Private Function OGREGUIBase_PrintData(ByVal fmt As String) As Variant
End Function

Private Property Get OGREGUIBase_Commands() As Boolean
End Property

Private Property Let OGREGUIBase_Commands(ByVal RHS As Boolean)
End Property

Private Property Get OGREGUIBase_Editable() As Boolean
End Property

Private Property Let OGREGUIBase_Editable(ByVal RHS As Boolean)
End Property

Private Property Let OGREGUIBase_hSize(ByVal RHS As Long)
End Property

Private Property Get OGREGUIBase_hSize() As Long
End Property

Private Property Let OGREGUIBase_ScrollBars(ByVal RHS As Boolean)
End Property

Private Property Get OGREGUIBase_ScrollBars() As Boolean
End Property

Private Property Let OGREGUIBase_vSize(ByVal RHS As Long)
End Property

Private Property Get OGREGUIBase_vSize() As Long
End Property
