VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "DXCLASS"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Option Explicit

' Timer Variables
Private Type LARGE_INTEGER
    lowpart As Long
    highpart As Long
End Type

Private Declare Function QueryPerformanceCounter Lib "kernel32" (lpPerformanceCount As LARGE_INTEGER) As Long
Private Declare Function QueryPerformanceFrequency Lib "kernel32" (lpFrequency As LARGE_INTEGER) As Long
Private m_PerfFrequency As LARGE_INTEGER
Private m_CounterStart As LARGE_INTEGER
Private m_CounterEnd As LARGE_INTEGER
Private m_crFrequency As Currency
Private m_bEnable As Boolean

Public AppComplete As Boolean
 
 ' for the performance counter
Private FrameQ As Single
Private Frames As Integer
Private oldFrames As Integer

' For subclassing the OGRE Form
Private Declare Function SetWindowLong& Lib "user32" Alias "SetWindowLongA" (ByVal hWnd As Long, ByVal nIndex As Long, ByVal dwNewLong As Long)

' Temp X for Window Routines
Private tx As Integer
Private aRect As RECT
Private anElement As OGREGUIBase
Private ClearRect(0 To 0) As D3DRECT

Public Sub AddWindow(hWnd As Long)
    ' Make sure we are not running in fullscreen, otherwise what is the point
    If Not fScreen Then
        WindowCount = WindowCount + 1
        ReDim Preserve WindowHwnd(WindowCount)
        ReDim Preserve Clipper(WindowCount)
        Set Clipper(WindowCount) = DD.CreateClipper(0)
    End If
End Sub

Public Function Initialize(Optional SubWinHwnd As Long = 0, Optional hWnd As Long = 0, Optional DriverDialog As Boolean = True, Optional ThreeD As Boolean = True, _
    Optional minBitDepth As Byte = 16, Optional maxBitDepth As Byte = 16, Optional minWidth As Long = 640, Optional maxWidth As Long = 1024) As Boolean
    
    On Error GoTo errs
    Dim ErrString As String
    ErrString = "OGREINIT: LOGO"
    
    ThreeDim = ThreeD
    'LOGO.Show
    'Do
    '    DoEvents
    'Loop Until Done
    'unload logo
    WindowHwnd(1) = IIf(hWnd <> 0, hWnd, OGREForm.hWnd)
    SubClassHwnd = IIf(SubWinHwnd <> 0, SubWinHwnd, WindowHwnd(1))
    DX7.GetWindowRect WindowHwnd(1), m_WinRect

    ' enumerate DD
    Dim I As Long, ddsd As DDSURFACEDESC2
    Dim DDenum As DirectDrawEnum
    Set DDenum = DX7.GetDDEnum
    DD_Guid = DDenum.GetGuid(1)
    DD_GuidDesc = DDenum.GetDescription(1)
    Set DDenum = Nothing
    Set DD = DX7.DirectDrawCreate(DD_Guid)
    
    ' If the threeD boolean is set then
    ' Enumerate direct3d drivers
    Dim tDevices As Direct3DEnumDevices
    Set IMode = DD.GetDirect3D
    ErrString = "OGREINIT: D3Denum"
    Set tDevices = IMode.GetDevicesEnum
    If ThreeD Then
        For I = 1 To tDevices.GetCount
            Drivers.List1(0).AddItem tDevices.GetDescription(I)
            Drivers.List1(0).ListIndex = Drivers.List1(0).ListCount - 1
        Next I
    Else
        D3D_GuidDesc = tDevices.GetDescription(1)
        D3D_Guid = tDevices.GetGuid(1)
    End If
    
    ' If we need a driver dialog, build the lists
    If DriverDialog Then
        Dim DisplayEnum As DirectDrawEnumModes
        Set DisplayEnum = DD.GetDisplayModesEnum(DDEDM_DEFAULT, ddsd)
        For I = 1 To DisplayEnum.GetCount
            DisplayEnum.GetItem I, ddsd
                With ddsd
                    If .lWidth >= minWidth And .lWidth <= maxWidth And _
                        .ddpfPixelFormat.lRGBBitCount >= minBitDepth And .ddpfPixelFormat.lRGBBitCount <= maxBitDepth Then
                            Drivers.List1(1).AddItem .lWidth & "x" & .lHeight & "x" & .ddpfPixelFormat.lRGBBitCount
                            Drivers.List1(1).ListIndex = Drivers.List1(1).ListCount - 1
                    End If
                End With
        Next I
        Set DisplayEnum = Nothing
    
        If Drivers.List1(1).ListCount = 0 Then
            MsgBox ("There are no compatible devices on your system")
            GoTo errs
            Exit Function
        End If
    
        Drivers.Show vbModal
        If Not InitTrue Then Exit Function
        If Drivers.Windowed.Value = 0 Then
            fScreen = True
        Else
            PrevWndProc = SetWindowLong(SubClassHwnd, GWL_WNDPROC, AddressOf WindowProc)
        End If
    
        With Drivers.List1(0)
            D3D_GuidDesc = tDevices.GetDescription(.ListIndex + 1)
            D3D_Guid = tDevices.GetGuid(.ListIndex + 1)
        End With
    Else
        PrevWndProc = SetWindowLong(SubClassHwnd, GWL_WNDPROC, AddressOf WindowProc)
    End If
    Set tDevices = Nothing
    
    If fScreen Then
        Dim Str As String, Pos As Byte
        Str = Drivers.List1(1).List(Drivers.List1(1).ListIndex)
        With m_WinRect
            I = InStr(1, Str, "x", vbTextCompare)
            .Right = CInt(Left(Str, I - 1))
            Pos = I + 1
            I = InStr(Pos, Str, "x", vbTextCompare)
            .Bottom = CInt(Mid(Str, Pos, I - Pos))
            winBPP = CInt(Mid(Str, I + 1, Len(Str) - I))
        End With
    End If
        
    Unload Drivers
    
    ReDim Clipper(1) As DirectDrawClipper
    Initialize = LoadDevices
    ResizeOK = True
    Exit Function
errs:
    Call anErr.AppErr(ErrString)
End Function

Public Sub BeginScene()
    If ThreeDim Then Device.BeginScene
    StartCounter
End Sub

Public Sub EndScene(WindowIndex As Byte)
    On Error Resume Next
    Clipper(WindowIndex).SetHWnd WindowHwnd(WindowIndex)
    sPrimary.SetClipper Clipper(WindowIndex)
    DX7.GetWindowRect WindowHwnd(WindowIndex), m_WinRect
    If WindowIndex = 1 Then
        Set anElement = GUIelements.GetElement("CONSOLE")
        If anElement.Active Then anElement.Render
    End If
    If ThreeDim Then
        Device.EndScene
        ClearRect(0).X2 = m_WinRect.Right - m_WinRect.Left
        ClearRect(0).Y2 = m_WinRect.Bottom - m_WinRect.Top
        Device.Clear 1, ClearRect(), D3DCLEAR_ZBUFFER, 0, 1, 0
        sBackBuffer.BltFast 0, 0, s3D, aRect, DDBLTFAST_DONOTWAIT
        If fScreen Then s3D.BltColorFill aRect, 0
    End If
    
    If WindowIndex = 1 Then
        If CameraInfo Then
            tx = (m_WinRect.Right - m_WinRect.Left) - 65
            sBackBuffer.DrawText tx - 65, m_WinRect.Top + 65, "Horz: " & Camera.LookHorz, False
            sBackBuffer.DrawText tx - 65, m_WinRect.Top + 85, "Vert: " & Camera.LookVert, False
            sBackBuffer.DrawText tx - 65, m_WinRect.Top + 105, "   X: " & Camera.CameraFrom.x, False
            sBackBuffer.DrawText tx - 65, m_WinRect.Top + 125, "   Y: " & Camera.CameraFrom.y, False
            sBackBuffer.DrawText tx - 65, m_WinRect.Top + 145, "   Z: " & Camera.CameraFrom.z, False
        End If
        If FPSON Then
            tx = (m_WinRect.Right - m_WinRect.Left) - 65
            sBackBuffer.SetForeColor RGB(255, 200, 125)
            sBackBuffer.DrawText tx - 65, 45, "FPS: " & oldFrames, False
            sBackBuffer.DrawText tx - 65, 65, "Polys: " & PolyCount, False
            PolyCount = 0
            Frames = Frames + 1
            StopCounter
            FrameQ = FrameQ + TimeElapsed
            If FrameQ > 1000 Then
                FrameQ = 0
                oldFrames = Frames
                Frames = 0
            End If
        End If
    End If
    
    sPrimary.Blt m_WinRect, sBackBuffer, aRect, DDBLTFAST_DONOTWAIT
    sBackBuffer.BltColorFill aRect, 0
    DoEvents
End Sub

Public Property Get WinRect() As RECT
    With WinRect
        .Top = m_WinRect.Top
        .Bottom = m_WinRect.Bottom
        .Left = m_WinRect.Left
        .Right = m_WinRect.Right
    End With
End Property

Public Property Get OGREDD() As DirectDraw7
    Set OGREDD = DD
End Property

Public Property Get OGREDevice() As Direct3DDevice7
    Set OGREDevice = Device
End Property

Public Property Get OGREDx7() As DirectX7
    Set OGREDx7 = DX7
End Property

Public Property Get OGRE3DS() As OGRE3DSmodule
    If TDS Is Nothing Then Set TDS = New OGRE3DSmodule
    Set OGRE3DS = TDS
End Property

Public Property Get OGRESurface() As OGRESurfaces
    If Surfaces Is Nothing Then Set Surfaces = New OGRESurfaces
    Set OGRESurface = Surfaces
End Property

Public Property Get OGRELight() As OGRELights
    If Lights Is Nothing Then Set Lights = New OGRELights
    Set OGRELight = Lights
End Property

Public Property Get OGREMesh() As OGREMeshes
    If Meshes Is Nothing Then Set Meshes = New OGREMeshes
    Set OGREMesh = Meshes
End Property

Public Property Get OGRECamera() As OGRECams
    If Camera Is Nothing Then Set Camera = New OGRECams
    Set OGRECamera = Camera
End Property

Public Property Get aPrimary() As DirectDrawSurface7
    Set aPrimary = sPrimary
End Property

Public Property Get aBackBuffer() As DirectDrawSurface7
    Set aBackBuffer = sBackBuffer
End Property

Public Property Get a3dsurface() As DirectDrawSurface7
    Set a3dsurface = s3D
End Property

Public Property Get aZbuffer() As DirectDrawSurface7
    Set aZbuffer = sZbuffer
End Property

Public Property Get Pi() As Single
    Pi = 3.141592654
End Property
    
Public Property Get Rads(num As Variant) As Single
    Rads = 0.0174532925222 * num
End Property

Public Property Get Degrees(num As Variant) As Single
    Degrees = 57.2957795056 * num
End Property

Public Property Get FullScreen() As Boolean
    FullScreen = fScreen
End Property

Public Property Get ddGuidDesc() As String
    ddGuidDesc = DD_GuidDesc
End Property

Public Property Get D3DGuid() As String
    D3DGuid = D3D_Guid
End Property

Public Property Get KeyState(myKey As Integer) As Boolean
    KeyState = Keys(myKey)
End Property

Private Sub Class_Initialize()
    Set DX7 = New DirectX7
    m_bEnable = CBool(QueryPerformanceFrequency(m_PerfFrequency))
    m_crFrequency = Large2Currency(m_PerfFrequency)
    FrameQ = 0
    Frames = 0
    oldFrames = 0
    FPSON = True
    CameraInfo = False
    WindowCount = 1
    ReDim WindowHwnd(1) As Long
End Sub

Private Sub Class_Terminate()
    QuitDX
End Sub

' Timer Functions
Property Get Delay() As Double
    Dim I As Integer
    Dim crTotalcount As Currency
    For I = 1 To 100
        Me.StartCounter
        Me.StopCounter
        crTotalcount = crTotalcount + (Large2Currency(m_CounterEnd) - Large2Currency(m_CounterStart))
    Next I
    Delay = ((crTotalcount / 100) / m_crFrequency) * 1000#
End Property

Private Function Large2Currency(largeInt As LARGE_INTEGER) As Currency
    If (largeInt.lowpart) > 0& Then
        Large2Currency = largeInt.lowpart
    Else
        Large2Currency = CCur(2 ^ 31) + CCur(largeInt.lowpart And &H7FFFFFFF)
    End If
    Large2Currency = Large2Currency + largeInt.highpart * CCur(2 ^ 32)
End Function

Public Sub StartCounter()
    Dim lResp As Long
    lResp = QueryPerformanceCounter(m_CounterStart)
End Sub

Public Sub StopCounter()
    Dim lResp As Long
    lResp = QueryPerformanceCounter(m_CounterEnd)
End Sub

Property Get TimeElapsed() As Double
    Dim crStart As Currency
    Dim crStop As Currency
    Dim crFrequency As Currency
    crStart = Large2Currency(m_CounterStart)
    crStop = Large2Currency(m_CounterEnd)
    TimeElapsed = ((crStop - crStart) / m_crFrequency) * 1000#
End Property
