VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "OGRE3DSmodule"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Option Explicit
Option Base 0

Private Enum colorBlocks
    Ambient
    Diffuse
    Specular
End Enum

Private Type tdsHeader
    Header As Integer
    Length As Long
End Type

Private Type aFace
    a As Integer
    b As Integer
    C As Integer
    flags As Integer
End Type

Private Type UVmap
    U As Single
    V As Single
End Type

Private Type udColorByte
    Red As Byte
    Green As Byte
    Blue As Byte
End Type

Private Type aMaterial
    MatName As String
    Ambient As D3DCOLORVALUE
    Diffuse As D3DCOLORVALUE
    Specular As D3DCOLORVALUE
    MapName As String       ' Diffuse Map
    MapPercent As Integer   ' Percentage map is used
End Type

Public Sub Load(filename As String, aMeshName As String, Optional theScale As Single = 1)
    
    On Error GoTo errs
    Dim ErrString As String
    ErrString = "3DS: Load3ds"
    
    Dim VbCounter As Long
    Dim ColorByte As udColorByte
    Dim PercentInt As Integer
    Dim cBlock As Byte              ' Type of color currently being imported. See colorblock Enum
    Dim Materials() As aMaterial
    Dim mCount As Integer           ' Number of loaded materials
    
    Dim Info As tdsHeader           ' Header of Chunk
    Dim Index As Long               ' Index in File -- filepos
        
    Dim MeshName As String          ' Current Mesh Name
    Dim Done As Boolean
    
    Dim vcount As Long              ' redundant vertex counter
    Dim Vertices As Integer         ' ""
    Dim Faces As Integer            ' Numbder of faces
    Dim VertexList() As D3DVECTOR   ' #DS file Vertexlist
    Dim Facelist() As aFace         ' Facelist
    Dim vbuf() As Long              ' redunant vertexlist for vertex buffer
    'Dim MeshVertices() As D3DVERTEX ' Actual constructor for vertex buffer
    
    Dim UVCoords() As UVmap         ' #DS file UV coordinates
    Dim UVbuf() As UVmap            ' Buffer for MeshVertices construction
    Dim nBuf() As D3DVECTOR         ' Buffer for the temp face Normals
    Dim Normals() As D3DVECTOR      ' Array to hold temporary face normals
    
    Dim tVector As D3DVECTOR
    Dim char As Byte
    Dim Strz As String              ' All Generic definitions for reading
    Dim Dword As Long               ' types stored in #DS file via C typedefs
    Dim word As Integer
    Dim Real As Single
    Dim I As Long
        
    Dim UVCoordsTrue As Boolean
    UVCoordsTrue = False
        
    Dim MinX, MinY, MinZ As Single
    Dim MaxX, MaxY, MaxZ As Single
    
    Index = 1
    ChDir App.Path
    Open filename & ".3ds" For Binary As #1
    
    While Not EOF(1)
        Get #1, Index, Info
        Index = Index + 6
        
        Select Case Info.Header
            Case &H4D4D:    ' OGRE Chunk
                ErrString = "OGRE Chunk"
                
            Case &H2:       ' 3DS Version Number
                ErrString = "3DS Version"
                Get #1, Index, Dword
                Index = Index + Len(Dword)
                
            Case &H3D3D:    ' 3D Editor Header
                ErrString = "3D Editor Chunk"
                
            Case &H3D3E:    ' Mesh Version
                ErrString = "Mesh Version"
                Get #1, Index, Dword
                Index = Index + Len(Dword)
                
            Case &H4000:    ' Object Block -- Includes Name
                ErrString = "Object Block"
                Done = False
                MeshName = ""
                While Not Done
                    Get #1, Index, char
                    If char <> 0 Then
                        MeshName = MeshName + Chr(char)
                    Else
                        Done = True
                    End If
                    Index = Index + Len(char)
                Wend
                
            Case &H4100:    ' Triangular Mesh
                ErrString = "Triangular Mesh"
                
            Case &H4110:    ' Verticies List
                ErrString = "Vertices"
                Get #1, Index, Vertices
                Index = Index + Len(Vertices)
                ReDim VertexList(Vertices)
                Get #1, Index, VertexList
                Index = Index + Len(VertexList(0)) * CLng(Vertices)
                
                MinX = 500000:  MinY = MinX: MinZ = MinY
                MaxX = -500000: MaxY = MaxX: MaxZ = MaxY
                  
                For I = 0 To Vertices - 1
                    With VertexList(I)
                        VertexList(I).x = VertexList(I).x * theScale
                        VertexList(I).y = VertexList(I).y * theScale
                        VertexList(I).z = VertexList(I).z * theScale
                        If .x < MinX Then MinX = .x
                        If .y < MinY Then MinY = .y
                        If .z < MinZ Then MinZ = .z
                    
                        If .x > MaxX Then MaxX = .x
                        If .y > MaxY Then MaxY = .y
                        If .z > MaxZ Then MaxZ = .z
                    End With
                Next I
                
            Case &H4120:    ' Face List
                ErrString = "Face List"
                Get #1, Index, Faces
                Index = Index + Len(Faces)
                
                ReDim Facelist(Faces)
                Get #1, Index, Facelist
                Index = Index + Len(Facelist(0)) * Faces
                
                vcount = -1
                ReDim vbuf(Faces * 3)
                ReDim UVbuf(Faces * 3)
                For I = 0 To Faces - 1
                    vcount = vcount + 3
                    'debug.print vcount
                    
                    If UVCoordsTrue Then
                        UVbuf(vcount - 2) = UVCoords(Facelist(I).a)
                        UVbuf(vcount - 1) = UVCoords(Facelist(I).b)
                        UVbuf(vcount) = UVCoords(Facelist(I).C)
                    End If
                    vbuf(vcount - 2) = Facelist(I).a
                    vbuf(vcount - 1) = Facelist(I).b
                    vbuf(vcount) = Facelist(I).C
                    
                    ' Make Face Normal
                    Dim a As D3DVECTOR, b As D3DVECTOR, C As D3DVECTOR
                    ReDim Preserve nBuf(vcount)
                    With DX7
                        ' Face Normal
                        .VectorSubtract a, VertexList(vbuf(vcount - 2)), VertexList(vbuf(vcount - 1))
                        .VectorSubtract b, VertexList(vbuf(vcount - 2)), VertexList(vbuf(vcount))
                        .VectorCrossProduct C, a, b
                        .VectorNormalize C
                        
                        nBuf(vcount) = C
                        nBuf(vcount - 1) = C
                        nBuf(vcount - 2) = C
                        
                        'ReDim Preserve Normals(I)
                        'DX.DX7.VectorAdd Normals(I), nBuf(vcount), nBuf(vcount - 1)
                        'DX.DX7.VectorAdd Normals(I), Normals(I), nBuf(vcount - 2)
                        'With Normals(I)
                        '    .X = .X / 3
                        '    .Y = .Y / 3
                        '    .z = .z / 3
                        'End With
                        'DX.DX7.VectorNormalize Normals(I)
                    End With
                Next I
                UVCoordsTrue = False
                
                'Dim Summer As D3DVECTOR, scount As Integer, J As Long
                'ReDim Preserve Normals(vcount - 1)
                'For J = 0 To vcount - 1
                '    scount = 0
                '    Summer.X = 0
                '    Summer.Y = 0
                '    Summer.z = 0
                '    For I = 1 To vcount
                '        ' check if this vertex is used in another other face
                '        If I <> J And vbuf(I) = vbuf(J) Then
                '            DX.DX7.VectorAdd Summer, Summer, nBuf(I)
                '            DX.DX7.VectorAdd Summer, Summer, nBuf(J)
                '            scount = scount + 2
                '        End If
                '    Next I
                '    If scount > 0 Then
                '        Normals(J).X = Summer.X / scount
                '        Normals(J).Y = Summer.Y / scount
                '        Normals(J).z = Summer.z / scount
                '        DX.DX7.VectorNormalize Normals(J)
                '    End If
                'Next J
                
                ErrString = "Load3ds: Mesh Add"
                If Meshes Is Nothing Then Set Meshes = New OGREMeshes
                With Meshes
                    VbCounter = .Create("alex2", D3DPT_TRIANGLELIST)
                    
                    For I = 0 To vcount - 1
                        .CreateVertex VbCounter, VertexList(vbuf(I)).x, VertexList(vbuf(I)).y, VertexList(vbuf(I)).z, UVbuf(I).U, UVbuf(I).V
                    Next I
                End With
                
            Case &H4130:    ' Face Material List
                ErrString = "Face Material"
                Done = False
                Strz = ""
                While Not Done
                    Get #1, Index, char
                    If char <> 0 Then
                        Strz = Strz + Chr(char)
                    Else
                        Done = True
                    End If
                    Index = Index + Len(char)
                Wend
                
                Dim q As Integer
                For q = 1 To mCount
                    If Strz = Materials(q).MatName Then
                        ' Store the Material Here
                        Exit For
                    End If
                Next q
                
                Get #1, Index, word
                Index = Index + Len(word)
                For I = 1 To word
                    Get #1, Index, word
                    Index = Index + Len(word)
                Next I
                
            Case &H4140:    ' Face Texture Coordinate
                ErrString = "Face Texture Coordinates"
                Get #1, Index, word
                Index = Index + Len(word)
                ReDim UVCoords(word)
                Get #1, Index, UVCoords
                Index = Index + Len(UVCoords(0)) * CLng(word)
                UVCoordsTrue = True
            
            Case &H4160:
                ErrString = "Local Coordinate System"
                Get #1, Index, tVector
                Index = Index + Len(tVector)
                Get #1, Index, tVector
                Index = Index + Len(tVector)
                Get #1, Index, tVector
                Index = Index + Len(tVector)
                Get #1, Index, tVector
                'DD.MeshParent(ObjName2).Mesh(MeshName).position
                Index = Index + Len(tVector)
            
            Case &HA000:    ' Material Name
                ErrString = "Material Name"
                Done = False
                Strz = ""
                While Not Done
                    Get #1, Index, char
                    If char <> 0 Then
                        Strz = Strz + Chr(char)
                    Else
                        Done = True
                    End If
                    Index = Index + Len(char)
                Wend
                Materials(mCount).MatName = Strz
                
            Case &HAFFF:    ' Material Editor Chunk
                ErrString = "Material Editor Chunk"
                mCount = mCount + 1
                ReDim Preserve Materials(mCount)        ' Save stored materials
                
            Case &H10:      ' Single Color Chunk
                ErrString = "Single Color Chunk"
                Index = Index + Info.Length - 6
                
            Case &H11:      ' Byte Color Chunk
                ErrString = "Byte Color Chunk"
                Get #1, Index, ColorByte
                Index = Index + Len(ColorByte)
                
                Select Case cBlock
                    Case Ambient:
                        With Materials(mCount).Ambient
                            .a = 1
                            .R = ColorByte.Red / 255
                            .g = ColorByte.Green / 255
                            .b = ColorByte.Blue / 255
                        End With
                        
                    Case Diffuse:
                        With Materials(mCount).Diffuse
                            .a = 1
                            .R = ColorByte.Red / 255
                            .g = ColorByte.Green / 255
                            .b = ColorByte.Blue / 255
                        End With
                        
                    Case Specular:
                        With Materials(mCount).Specular
                            .a = 1
                            .R = ColorByte.Red / 255
                            .g = ColorByte.Green / 255
                            .b = ColorByte.Blue / 255
                        End With
                End Select
                
            Case &H30:      ' Percent Chunk Int format
                ErrString = "Percent Chunk INT"
                Get #1, Index, PercentInt
                Index = Index + Len(PercentInt)
                
            Case &H31:      ' Percent Chunk Float format
                ErrString = "Percent Chunk Float"
                Index = Index + Info.Length - 6
            
            Case &HA010:    ' Ambient color
                ErrString = "Ambient Color"
                cBlock = Ambient
                
            Case &HA020:    ' Diffuse Color
                ErrString = "Diffuse Color"
                cBlock = Diffuse
                
            Case &HA030:    ' Specular Color
                ErrString = "Specular Color"
                cBlock = Specular
                
            Case &HA200:    ' Map #1 -- diffuse?
                cBlock = Diffuse
                
            Case &HA300:    ' Map FileName
                ErrString = "Map File Name"
                Done = False
                Strz = ""
                While Not Done
                    Get #1, Index, char
                    If char <> 0 Then
                        Strz = Strz + Chr(char)
                    Else
                        Done = True
                    End If
                    Index = Index + Len(char)
                Wend
                Select Case cBlock
                    Case Diffuse:
                        Materials(mCount).MapName = Strz
                End Select
                
                'debug.print "Material Map Name: " & Strz
                
            Case &HA33A:    ' Map #2 -- Ambient?
                cBlock = Ambient
            
            Case &HA354
                ErrString = "V scaling for Map"
                Index = Index + Info.Length - 6
                
            Case &HA356
                ErrString = "U scaling for Map"
                Index = Index + Info.Length - 6
                
            Case &HA358
                ErrString = "U offset for Map"
                Index = Index + Info.Length - 6
                
            Case &HA35A
                ErrString = "V offset for Map"
                Index = Index + Info.Length - 6
                
            Case &HA35C
                ErrString = "Rotation Angle for Map"
                Index = Index + Info.Length - 6
                
            Case &H100:     ' One Unit
                ErrString = "One Unit"
                Get #1, Index, Real
                Index = Index + Len(Real)
                
            Case Else       ' Unknown Chunk
                ErrString = "Unknown Chunk"
                Index = Index + Info.Length - 6
        End Select
    Wend
    Close #1
    Exit Sub
errs:
    Call anErr.AppErr(ErrString)
End Sub
